<script lang="js">
import Vue from 'vue';
import { NextStepAlt } from '../components/common/index.vue';
import {
  BlurbGrid,
  CustomerLogos,
  FeatureShowcase,
  HeroScrollGallery,
  IntroBlock,
  RecognitionSpotlight,
  TabbedCaseStudies,
  TabbedFeatures,
} from '../components/home/index.vue';
import { getPageMetadata } from '../common/meta';
import { getClient } from '~/plugins/contentful.js';
import { homepageHelper } from '~/services/homepage/homepage.service';
import { convertToCaseSensitiveLocale } from '../common/util';
import { CONTENT_TYPES } from '../common/content-types';
import { UserSegmentsMixin } from '../mixins/index';
import { COMPONENT_NAMES } from '../common/constants';

export default Vue.extend({
  components: {
    CustomerLogos,
    NextStepAlt,
    IntroBlock,
    BlurbGrid,
    FeatureShowcase,
    HeroScrollGallery,
    TabbedFeatures,
    TabbedCaseStudies,
    RecognitionSpotlight,
  },
  mixins: [UserSegmentsMixin],
  async asyncData({ i18n }) {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        include: 10,
        'sys.id': `64IfZK32A8vBQr2vvCHkOT`,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });

      const [entry] = items;

      const doc = homepageHelper(entry.fields);

      return { doc };
    } catch (e) {
      throw new Error(e);
    }
  },
  head() {
    return getPageMetadata(
      this.doc,
      this.$route.fullPath,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  computed: {
    // Both segmented components data needs to be filtered
    customerLogosToRender() {
      // Property this.segmentCustomersIndex is set in the UserSegmentsMixin
      return {
        ...this.doc?.personalized_customer_logos[this.segmentCustomersIndex],
      };
    },
    caseStudiesToRender() {
      // Property this.segmentCasesIndex is set in the UserSegmentsMixin
      return {
        ...this.doc?.personalized_tabbed_case_studies[this.segmentCasesIndex],
      };
    },
  },
  mounted() {
    // Let's wait until the window is loaded to ensure data in mixin's beforeMount is available
    window.addEventListener('load', this.loadSegment);
  },
  destroyed() {
    window.removeEventListener('resize', this.onResize);
    window.removeEventListener('load', this.loadSegment);
  },
  methods: {
    onResize() {
      this.width = window.innerWidth;
    },
    onFreeTrialClick() {
      this.$refs.launchDarklyButtons.fireCustomEvent(
        'clicked-hero-redesign-free-trial-cta',
      );
    },
    loadSegment() {
      // Each of these functions sets the appropriate segment and corresponding index used in the computed properties
      this.setSegment(
        this.doc?.personalized_customer_logos,
        COMPONENT_NAMES.CUSTOMER_LOGOS,
      );
      this.setSegment(
        this.doc?.personalized_tabbed_case_studies,
        COMPONENT_NAMES.TABBED_CASE_STUDIES,
      );
    },
  },
});
</script>

<template>
  <div>
    <div
      class="homepage-container"
      :class="!doc.duo_pro_hero && 'gradient-background'"
    >
      <HeroScrollGallery
        v-if="!doc.duo_pro_hero && doc.hero_scroll_gallery"
        v-bind="doc.hero_scroll_gallery"
        @hero-free-trial-cta-click="onFreeTrialClick()"
      />
      <!-- Show `CustomerLogos` with personalized content in computed properties -->
      <!-- We need to set a min-height for loading state height consistency -->
      <SlpContainer
        v-if="doc.personalized_customer_logos"
        style="min-height: 193px"
      >
        <CustomerLogos :data="customerLogosToRender" has-loading-state />
      </SlpContainer>

      <!-- Default component implementation before personalization -->
      <SlpContainer v-else>
        <CustomerLogos :data="doc.customer_logos_block" />
      </SlpContainer>

      <IntroBlock v-if="doc.intro_block" :data="doc.intro_block" />
      <BlurbGrid v-if="doc.blurb_grid" :data="doc.blurb_grid" />

      <SlpContainer v-if="doc.feature_showcase">
        <FeatureShowcase :data="doc.feature_showcase" />
      </SlpContainer>
      <TabbedFeatures v-if="doc.tabbed_features" :data="doc.tabbed_features" />

      <!-- Show `TabbedCaseStudies` with personalized content in computed properties -->
      <TabbedCaseStudies
        v-if="doc.personalized_tabbed_case_studies"
        v-bind="caseStudiesToRender"
      />

      <!-- Default component implementation before personalization -->
      <TabbedCaseStudies v-else v-bind="doc.quotes_carousel_block" />

      <RecognitionSpotlight
        v-if="doc.recognition_spotlight"
        :data="doc.recognition_spotlight"
      />

      <NextStepAlt />
    </div>
  </div>
</template>
<style scoped lang="scss">
.homepage-container {
  position: relative;
  background-repeat: no-repeat;
  background-size: 300% 1400px;
  background-position: center top;
  z-index: 1;
  overflow: hidden;
  @media (min-width: $breakpoint-sm) {
    background-size: 100% 1400px;
    background-position: right top;
  }

  &.gradient-background {
    background-image: url('/nuxt-images/home/gradient.png');
  }

  &:before {
    content: '';
    position: absolute;
    width: 100%;
    height: 746px;
    left: 0;
    top: 700px;
    z-index: -1;
    background: linear-gradient(
      0deg,
      #fff 0%,
      #fff 24.59%,
      rgba(255, 255, 255, 0) 100%
    );
  }
}
</style>
